Subject: Re: bug#61319: 30.0.50; 'M-x select-frame-by-name' --with-pgtk does not switch focused frame

From: Protesilaos Stavrou <[email-masked]>
Date: Thu, 09 Feb 2023 10:01:25 +0200

> From: Po Lu <[email-masked]>
> Date: Mon,  6 Feb 2023 21:40:59 +0800

> [... 17 lines elided]

>> You are saying that select-frame-set-input-focus doesn't move the
>> input focus to the newly-selected frame?  But that is only "best
>> effort":
>>
>>   select-frame-set-input-focus is a byte-compiled Lisp function in
>>   ‘frame.el’.
>>
>>   (select-frame-set-input-focus FRAME &optional NORECORD)
>>
>>   Select FRAME, raise it, and set input focus, if possible.
>>                           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
>> Perhaps Po Lu could try fixing this, but in general Lisp programs and
>> users should not rely on success in these cases, because the WM can
>> actively prevent Emacs from giving the frame input focus.
>
> The Wayland protocol itself prevents Emacs from doing this.
>
> GTK 3 uses a private Wayland protocol extension named ``gtk-shell''
> which is implemented only by GNOME's Wayland compositor; it does not
> support the other extension typically used to activate toplevels.

Thank you for the explanation!  In that case there is nothing we can do
about it and this bug can be closed.

> Unless you're using GNOME Shell, I don't think we will be able to make
> this work, sorry.  If you do, however, it should already work.  So
> please tell us what Wayland compositor you are using.

The issue occurs on GNOME Wayland.  I normally use X with a tiling
window manager.  There the Emacs frame selection works as intended.

-- 
Protesilaos Stavrou
https://protesilaos.com